# PANDEM - Source
Integrate heterogeneous publuc health surveillance data sources into a coherent data base for PANDEM-2 project. 

## Description
Identify, map and integrate multiple pandemic related data into a coherent pandemic-management database. Developed within the H2020 project PANDEM-2, Pandem-Source allows users to systematically capture, standardize and analyze data coming from international and national surveillance databases, participatory surveillance projects, social networks and mass media. This tool is focused on flexibility so adding new sources or variables can be easily done as is required during a pandemic episode. 

## Target users
Public health data experts and data managers needing integrate several surveillance data.

## Approach
Data integration follow a semantic approach. Data sources need to be described using a Data Labelling Schema (DLS) file that specifies the acquisition chennel (URL, git, local file or script) the format and how to map the input data to Pandem-Source variables. If further customistions are needed, the user can define them using simple python scripts.

The DLS ensures each source and variable is properly documented knwing its origin, meaning and data quality.

## Supported sources
Pandem-Source is designed to be flexible and extensible so new sources can be easily added by end users. In order to demontstrate this principle. The following sources are supported Out of the Box

### Sources for indicators
- [COVID19 Data Hub](https://covid19datahub.io/) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/covid19-datahub.json)
- [ECDC Atlas](https://www.ecdc.europa.eu/en/surveillance-atlas-infectious-diseases) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-atlas-influenza.json)
- [ECDC COVID19 Datasets](https://www.ecdc.europa.eu/en/covid-19/data) see source definitions for [variants](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-covid19-variants.json), [age group](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-covid19-age-group.json), [daily cases](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-covid19-daily.json), [goverments measures](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-covid19-measures.json), [vaccination](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-covid19-vaccination.json)
- [ECDC COVID19 Simulated data](https://github.com/maous1/Pandem2simulator) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ecdc-covid19-age-group-variants.json)
- [Serotracker](https://serotracker.com/en/Explore) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/serotracker.json)
- [Open Sky Nerwork](https://opensky-network.org/) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/opensky-network-coviddataset.json)
- [Influenza Net](http://www.influenzanet.info) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/influenza-net.json)
- [MediSys](https://medisys.newsbrief.eu/medisys/) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/medisys.json)
- [Twitter](https://twitter.com) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/twitter.json)
- [User provided data](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/input-local-defaults/M.12%20Upload%20templates_end_users.xlsx?raw=true). You can use this data template to easily integrate your own real or ficticious datasets.

### Sources for referentials
- [Eurostats NUTS](https://ec.europa.eu/eurostat/web/gisco/geodata/reference-data/administrative-units-statistical-units/nuts) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/nuts-eurostat.json)
- [Our airports](https://ourairports.com/) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ourairports.json)
- [Geonames](https://www.geonames.org/) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/geonames-countries.json)
- [ICD-10-CM](https://www.cdc.gov/nchs/icd/icd10cm.htm) see [source definition](https://github.com/pandem2/pandem-source/blob/main/pandemsource/data/DLS/ICD-10-siseases-list.json) 

## User Interface - timeseries explorer
![Time series](https://github.com/pandem2/pandem-source/raw/main/img/P2.timeseries.png)

## User Interface - Integration dashboard
![Integration dashboard](https://github.com/pandem2/pandem-source/raw/main/img/P2.Integration.png)

## Requirements
- Python 3.7 or higher
- R 3.6.3 or higher
- Docker (optional for supporting machine learning article classification)

## Installing from pip
If you want to customize the installation folder (defaulted to ~/.pandemsource) you need to set the environment variable PANDEM\_HOME to a different folder
```
pip install pandem-source

python -m pandemsource setup --install

```

# Installing for contributors
If you want to customize the installation folder (defaulted to ~/.pandemsource) you need to set the environment variable PANDEM\_HOME to a different folder

```
git clone https://github.com/pandem2/pandem-source

cd pandem-source

make init

make install

source env/bin/activate

python -m pandemsource setup --install

```

# Defining sources o monitor
PANDEM-Source comes with a list of predefined sources it can monitor, but they are not all enabled by default.
In order to use them them you have to manually activate them with the 'setup' command.
## See all avaiable sources

```
python -m pandemsource setup -h
```

## Activating a particular source
```
# Activating ECDC covid19 dataset monitoring
python -m pandemsource setup --ecdc-covid19

# Activating preloaded 2023 functional excercise data
python -m pandemsource setup --pandem-2-2023-fx
```
# Running Pandem-Source

- Set the PANDEM\_HOME variable to a local foder (only if you have customized the default installation folder)
``` 
export PANDEM\_HOME=your data folder here 
```
- Running monitoring and dashboard 
```
python -m pandemsource start -d 

```
- Accessing the dashboard from http://localhost:8001 to see the progress and integrated time series

## Troubleshooting

If the command `python -m pandemsource start -d --no-nlp` does not work. Please make sure you've installed *R 3.6.3 or higher*. If R is properly installed, please make sure you've also installed required dependencies with:

(In your terminal)
```bash
sudo apt install libxml2-dev libsodium-dev libssl-dev libcurl4-openssl-dev
```

(In the R interpreter)
```R
install.packages(c("epitweetr", "dplyr", "shiny", "plotly", "DT", "jsonlite", "httr"))
```


# PANDEM 2

PANDEM-2 is a H2020 EU-funded project that aims to develop new solutions for efficient, EU-wide pandemic management. The goal of PANDEM-2 is to prepare Europe for future pandemics through innovations in training and to build capacity between EU member states responding to pandemics on a cross-border basis.

library(dplyr)
library(COVID19)
message("getting data for covid19datahub for Country POL")
df <- covid19(country = c("POL"), level = 3)

df$key_nuts <- ifelse(is.na(df$key_nuts), df$iso_alpha_2, df$key_nuts)
df$part <- paste(df$iso_alpha_2, substr(df$date, 1, 7), sep = "_")
for(n in unique(df$part)) {
  ddf <- df %>% 
    filter(part == n)
  write.csv(ddf, paste(n, ".csv", sep = ""), row.names = FALSE)
}
message("getting covid-19 datahub data done for country POL done")

`%>%` <- magrittr::`%>%`

df1 <- data.frame(reporting_time, article_count) %>% dplyr::mutate(reporting_date = substr(reporting_time, 1, 10)) 
df2 <- df1 %>% dplyr::group_by(reporting_date ) %>% dplyr::summarize(count = sum(article_count))

df2$alert <- epitweetr::ears_t_reweighted(ts = df2$count, alpha = 0.025, alpha_outlier = 0.05, k_decay = 4, no_historic = 7, same_weekday_baseline = T)$alarm0
dplyr::inner_join(df1, df2, by = "reporting_date")$alert

library(Pandem2simulator)
library(ggplot2)
library(dplyr)
library(tidyr)

library(XML)
library(httr)
library(jsonlite)



get_df_age_group <- function() {
    json_payload <- '{
        "select": ["confirmed_cases", "age_group", "geo_code", "reporting_week"],
        "filter": {
            "source": "ecdc-covid19-age-group"
        }
    }'

    return(request_dataset(json_payload))
}

get_df_variants <- function() {
    json_payload <- '{
        "select": ["confirmed_cases", "variant", "geo_code", "reporting_week"],
        "filter": {
            "source": "ecdc-covid19-variants"
        }
    }'

    return(request_dataset(json_payload))
}

request_dataset <- function(json_payload) {
    req <- httr::POST(
        "http://127.0.0.1:8000/dataset",
        body = json_payload, encode = "json"
    )
    if (req$status_code == 200) {
        data <- httr::content(req)$dataset
        json <- jsonlite::toJSON(data, auto_unbox = T, null = "null")
        res_df <- as.data.frame(jsonlite::fromJSON(json, simplifyDataFrame = T))
        return(res_df)
    } else {
        stop("Error while obtaining data series")
    }
}

check_dataframe <- function(df) {
    if (dim(df)[1] == 0 || dim(df)[2] == 0) {
        stop("Dataframe is empty. Please check that this source has been completely acquired before retrying.")
    }
}

#' Normalizes dataframe columns for UCL-algorithm
normalize_dataframe <- function(df) {
    if ("reporting_period" %in% colnames(df)) {
        names(df)[names(df) == "reporting_period"] <- "time"
        fun1 <- function(time) strftime(time, format = "%G-%V")
        df$year_week <- mapply(fun1, df$time)
    }
    if ("geo_code" %in% colnames(df)) {
        names(df)[names(df) == "geo_code"] <- "country_code"
    }
    if ("variant" %in% colnames(df)) {
        names(df)[names(df) == "confirmed_cases"] <- "new_cases"
        df$number_sequenced <- NA
    }
    return(df)
}


#' Keeps only useful columns for UCL-algorithm and eliminates rows
#' that are not in the given interval
format_dataframe <- function(df, start_date = "", end_date = "") {
    keeps <- c("country_code", "year_week", "time", "new_cases")
    if ("variant" %in% colnames(df)) {
        keeps <- append(keeps, "variant")
    } else {
        keeps <- append(keeps, "age_group")
    }
    df <- df[keeps]
    if (start_date != "" & end_date != "") {
        df <- df[is_in_date_range(df$time, start_date, end_date), ]
    }
    return(df)
}

is_in_date_range <- function(date2check_str, start_date_str, end_date_str) {
    date2check <- as.Date(date2check_str, "%Y-%m-%d")
    start <- as.Date(start_date_str, "%Y-%m-%d")
    end <- as.Date(end_date_str, "%Y-%m-%d")
    return(start <= date2check & date2check <= end)
}


normalize_mutation_dates <- function(df) {
  df = data_mutation[nchar(df$collection_date) == 10,]
  df$time <- df$collection_date
  df$year_week <- strftime(df$collection_date, "%G-%V")
  df
}

#normalize_dates <- function(data_mutation) {
#	data_mutation$collection_date <- mapply(normalize_date, data_mutation$collection_date)
#	names(data_mutation)[names(data_mutation) == "collection_date"] <- "time"
#	return(data_mutation)
#}

#normalize_date <- function(date) {
#    if (nchar(date) > 4) {
#        res <- date
#    } else {
#        res <- paste(date, "-01-01", sep = "")
#    }
#    return(as.Date(res, format = "%Y-%m-%d", origin = "1970-01-01"))
#}

write_country_csv <- function(df) {
    countries <- unique(df$country_code)
    for (country in countries) {
        df2write <- subset(
            df, df$country_code == country, c(
                "country_code",
                "year_week",
                "time",
                "variant",
                "position",
                "mutation",
                "new_cases"
            )
        )
        write.csv(df2write,
            file = paste(country, "_case_variants.csv", sep = "")
        )
    }
}

message("Getting age_group & variants dataframe... (1/6)")
variants_df <- get_df_variants()


message("Checking integrity of variants... (2/6)")
check_dataframe(variants_df)

message("Normalizing dataframes... (3/6)")
variants_df <- normalize_dataframe(variants_df)


message("Formatting dataframes... (4/6)")
filter_start_date <- min(variants_df$time, na.rm = TRUE)
filter_end_date <- max(variants_df$time, na.rm = TRUE)

variants_df_formatted <- format_dataframe(
    variants_df,
    start_date = filter_start_date, end_date = filter_end_date
)


# Filtering by country
message("Filtering by country...")
variants_df_formatted_country <- filter(variants_df_formatted, country_code %in% c("FR", "AT", "BE", "IT"))

message("Downloading Genomic Datasets from NCBI... (5/6)")
download_genomic_data(
    ecdcdata = variants_df_formatted_country,
    var_names_variant = "variant",
    path_dataformat = "/usr/bin/dataformat",
    path_dataset = "/usr/bin/datasets",
    path_nextclade = "/usr/bin/nextclade"
)
genomic_data <- read.csv("genomic_data.csv")
file.remove("genomic_data.csv")

message("Adding genomic data on the cases dataset... (6/7)")
genomic_data$time <- genomic_data$collection_date
data_mutation <- create_table_mutation(genomic_data)
data_mutation <- normalize_mutation_dates(data_mutation)

case_variants_genomic <- add_genomic_data(
   metadata = variants_df_formatted_country, 
   genomic_data = data_mutation, 
   var_names_merge=variant, 
   var_names_count=new_cases, 
   var_names_time=time
)

message("Selecting time correlated mutations on last 30 days... (7/7)")
case_variants_genomic_selected <- select_mutation(
  data = case_variants_genomic, 
  dateStart= as.Date(filter_end_date, format = "%Y-%m-%d") - 30, 
  dateEnd = as.Date(filter_end_date, format = "%Y-%m-%d"), 
  number=5,
  var_names_count=new_cases, 
  var_names_time=time
)

write_country_csv(case_variants_genomic_selected)

#cleaning data
file.remove(list.files("data/sars-cov-2", full.names = TRUE))
file.remove("data/sars-cov-2")
file.remove("data")
file.remove(list.files("Nextclade_results", full.names = TRUE))
file.remove("Nextclade_results")
file.remove("genomic_filter.fna")

# source https://staff.math.su.se/hoehle/blog/2020/04/15/effectiveR0.html
confirmed_cases = sapply(confirmed_cases, function(v) {if(is.na(v)) 0 else v})  

#' R_e(t) estimator with generation time GT (default GT=4). Note: The time t
#' is assigned to the last day in the blocks of cases on [t,t+1,t+2, t+3] vs.
#' [t+4,t+5,t+6, t+7], i.e. s=t-8 (c.f. p. 14 of 2020-04-24 version of the RKI paper)
#' @param ts - Vector of integer values containing the time series of incident cases
#' @param GT - PMF of the generation time is a fixed point mass at the value GT.

est_rt_last <- function(ts, GT=4L) {
  # Sanity check
  if (!is.integer(GT) | !(GT>0)) stop("GT has to be postive integer.")
    # Estimate, if s=1 is t-7
  res <- sapply( 1:length(ts), function(t) {
    if((t < 2*GT) || sum(ts[t-2*GT+1:GT]) == 0)
      NA
    else
      sum(ts[t-(0:(GT-1))]) / sum(ts[t-2*GT+1:GT])
  })
  names(res) <- names(ts)[(2*GT):length(ts)]
  return(res)
}

if(length(confirmed_cases)<9) { 
  sapply(confirmed_cases, function(v) NA)
} else {
  # using GT = 7 to limit dayofthe week impact
  est_rt_last(confirmed_cases, GT=7L)
}

library(XML)
library(httr)
library(dplyr)
library(jsonlite)
library(Pandem2simulator)
library(ggplot2)

eu_countries <- c(
    "germany" = "DE",
    "austria" = "AT",
    "belgium" = "BE",
    "bulgaria" = "BG",
    "cyprus" = "CY",
    "croatia" = "HR",
    "denmark" = "DK",
    "spain" = "SP",
    "estonia" = "EE",
    "finland" = "FI",
    "france" = "FR",
    "greece" = "GR",
    "hungary" = "HU",
    "ireland" = "IE",
    "italy" = "IT",
    "latvia" = "LV",
    "lithuania" = "LT",
    "luxembourg" = "LU",
    "malta" = "MT",
    "netherlands" = "NL",
    "poland" = "PL",
    "portugal" = "PT",
    "romania" = "RO",
    "slovakia" = "SK",
    "slovenia" = "SI",
    "sweden" = "SE",
    "czechia" = "CZ"
)

get_df_hospital_occupancy <- function() {
    json_payload <- '{
        "select": ["hospitalised_infected_patients_in_icu"],
        "filter": {
            "source": "ecdc-covid19-weekly-hospital-occupancy"
        }
    }'

    return(request_dataset(json_payload))
}

get_df_variants <- function() {
    json_payload <- '{
        "select": ["confirmed_cases", "variant", "geo_code", "reporting_week"],
        "filter": {
            "source": "ecdc-covid19-variants"
        }
    }'

    return(request_dataset(json_payload))
}

request_dataset <- function(json_payload) {
    req <- httr::POST(
        "http://127.0.0.1:8000/dataset",
        body = json_payload, encode = "json"
    )
    if (req$status_code == 200) {
        data <- httr::content(req)$dataset
        json <- jsonlite::toJSON(data, auto_unbox = T, null = "null")
        res_df <- as.data.frame(jsonlite::fromJSON(json, simplifyDataFrame = T))
        return(res_df)
    } else {
        message(req$status_code)
        stop("Error while obtaining data series")
    }
}

#' Normalizes dataframe columns for UCL-algorithm
normalize_dataframe <- function(df) {
    if ("reporting_period" %in% colnames(df)) {
        names(df)[names(df) == "reporting_period"] <- "time"
        fun1 <- function(time) strftime(time, format = "%Y-%V")
        df$year_week <- mapply(fun1, df$time)
    }
    if ("geo_code" %in% colnames(df)) {
        names(df)[names(df) == "geo_code"] <- "country_code"
    }
    if ("country_name" %in% colnames(df)) {
        names(df)[names(df) == "country_name"] <- "country_code"
        fun2 <- function(country_name) eu_countries(country_name)
        df$country_code <- mapply(fun2, df$country_code)
    }
    if ("variant" %in% colnames(df)) {
        names(df)[names(df) == "confirmed_cases"] <- "new_cases"
        df$number_sequenced <- NA
    }
    if ("hospitalised_infected_patients_in_icu" %in% colnames(df)) {
        names(df)[names(df) == "hospitalised_infected_patients_in_icu"] <- "new_cases"
    }
    return(df)
}

#' Keeps only useful columns for UCL-algorithm and eliminates rows
#' that are not in the given interval
format_dataframe <- function(df, start_date = "", end_date = "") {
    keeps <- c("country_code", "year_week", "time", "new_cases")
    if ("variant" %in% colnames(df)) {
        keeps <- append(keeps, "variant")
    }
    df <- df[keeps]
    if (start_date != "" & end_date != "") {
        df <- df[is_in_date_range(df$time, start_date, end_date), ]
    }
    return(df)
}

is_in_date_range <- function(date2check_str, start_date_str, end_date_str) {
    date2check <- as.Date(date2check_str, "%Y-%m-%d")
    start <- as.Date(start_date_str, "%Y-%m-%d")
    end <- as.Date(end_date_str, "%Y-%m-%d")
    return(start <= date2check & date2check <= end)
}

remove_exclusive_dates <- function(df1, df2) {
    # Mark as YES if couples date/country aren't in both dataframes else NO
    df1$check <- ifelse(is.na(match(
        paste0(df1$time, df1$country_code),
        paste0(df2$time, df2$country_code)
        )), "NO", "YES")
    df2$check <- ifelse(is.na(match(
        paste0(df2$time, df2$country_code),
        paste0(df1$time, df1$country_code)
        )), "NO", "YES")

    # Only keep row where check equals YES
    df1_without_exclusive <- df1[(df1$check == "YES"), ]
    df2_without_exclusive <- df2[(df2$check == "YES"), ]
    return(list(df1_without_exclusive, df2_without_exclusive))
}

write_country_csv <- function(df) {
    countries <- unique(df$country_code)
    for (country in countries) {
        df2write <- subset(
            df, df$country_code == country, c(
                "country_code", "year_week", "time", "variant", "new_cases"))
        write.csv(df2write,
            file = paste(country, "_hosp_occupancy_variants.csv", sep = "")
        )
    }
}

message("Getting hospital_occupancy dataframe... (1/7)")
hosp_occupancy_df <- get_df_hospital_occupancy()
message("Getting variants dataframe... (2/7)")
variants_df <- get_df_variants()

message("Normalizing dataframes... (3/7)")
hosp_occupancy_df_normalized <- normalize_dataframe(hosp_occupancy_df)
variants_df_normalized <- normalize_dataframe(variants_df)

message("Formatting dataframes... (4/7)")
filter_start_date <- min(variants_df_normalized$time, na.rm = TRUE)
filter_end_date <- max(variants_df_normalized$time, na.rm = TRUE)
hosp_occupancy_df_formatted <- format_dataframe(
    hosp_occupancy_df_normalized,
    start_date = filter_start_date, end_date = filter_end_date
)
variants_df_formatted <- format_dataframe(
    variants_df_normalized,
    start_date = filter_start_date, end_date = filter_end_date
)

message("Removing exclusive dates in both dataset... (5/7)")
dataframes <- remove_exclusive_dates(
    variants_df_formatted, hosp_occupancy_df_formatted)
variants_df_formatted <- dataframes[[1]]
hosp_occupancy_df_formatted <- dataframes[[2]]

message("Obtaining simulated case & hosp occupancy dataframe... (6/7)")
case_hosp_occupancy_aggregated <- simulator(
    trainset = variants_df_formatted,
    testset = hosp_occupancy_df_formatted, 
    var_names_geolocalisation = country_code,
    var_names_outcome = variant,
    var_names_count = new_cases,
    var_names_time = time,
    factor = 500
)
str(case_hosp_occupancy_aggregated)

message("Writing resulting datasets... (7/7)")
write_country_csv(case_hosp_occupancy_aggregated)

library(dplyr)
#dir.create(Sys.getenv("R_LIBS_USER"), recursive = TRUE)  # create personal library
#.libPaths(Sys.getenv("R_LIBS_USER")) 
#if(!require("COVID19")) {
#    devtools::install_github(repo = "covid19datahub/COVID19", ref = "b941b66e59b7b0aec4807eb5b28208abba66de4a", upgrade = "never", lib = Sys.getenv("R_LIBS_USER"))
    library(COVID19)
#}
message("getting data for covid19datahub :-) ")
df <- covid19(country = c(
  "AUT", "BEL", "BGR", "HRV", "CYP", "CZE", "DNK", "EST", "FIN", 
  "FRA", "DEU", "GRC", "HUN", "IRL", "ITA",
 "LVA", "LTU", "LUX", "MLT", "NLD", "POL", "PRT", "ROU", "SVK", "SVN", "ESP", "SWE", "GBR"
 ), level = 3
)

df$key_nuts <- ifelse(is.na(df$key_nuts), df$iso_alpha_2, df$key_nuts)
df$part <- paste(df$iso_alpha_2, substr(df$date, 1, 7), sep = "_")
for(n in unique(df$part)) {
  ddf <- df %>% 
    filter(part == n)
  write.csv(ddf, paste(n, ".csv", sep = ""), row.names = FALSE)
}
message("getting covid-19 datahub data done")

library(XML)
library(httr)
library(dplyr)
library(jsonlite)
library(Pandem2simulator)
library(ggplot2)


get_df_age_group <- function() {
    json_payload <- '{
        "select": ["confirmed_cases", "age_group", "geo_code", "reporting_week"],
        "filter": {
            "source": "ecdc-covid19-age-group"
        }
    }'

    return(request_dataset(json_payload))
}

get_df_variants <- function() {
    json_payload <- '{
        "select": ["number_detections_variant", "variant", "geo_code", "reporting_week"],
        "filter": {
            "source": "ecdc-covid19-variants"
        }
    }'

    return(request_dataset(json_payload))
}

request_dataset <- function(json_payload) {
    req <- httr::POST(
        "http://127.0.0.1:8000/dataset",
        body = json_payload, encode = "json"
    )
    if (req$status_code == 200) {
        data <- httr::content(req)$dataset
        json <- jsonlite::toJSON(data, auto_unbox = T, null = "null")
        res_df <- as.data.frame(jsonlite::fromJSON(json, simplifyDataFrame = T))
        return(res_df)
    } else {
        stop("Error while obtaining data series")
    }
}

#' Normalizes dataframe columns for UCL-algorithm
normalize_dataframe <- function(df) {
    if ("reporting_period" %in% colnames(df)) {
        names(df)[names(df) == "reporting_period"] <- "time"
        fun1 <- function(time) strftime(time, format = "%Y-%V")
        df$year_week <- mapply(fun1, df$time)
    }
    if ("geo_code" %in% colnames(df)) {
        names(df)[names(df) == "geo_code"] <- "country_code"
    }
    if ("number_detections_variant" %in% colnames(df)) {
        names(df)[names(df) == "number_detections_variant"] <- "new_cases"
        df$number_sequenced <- NA
    }
    if ("age_group" %in% colnames(df)) {
        df$age_group <- mapply(normalize_age_group, df$age_group)
        names(df)[names(df) == "confirmed_cases"] <- "new_cases"
    }
    return(df)
}

normalize_age_group <- function(age_group) {
    nb <- regmatches(age_group, gregexpr("[0-9]+", age_group, perl = TRUE))
    nb_size <- length(nb[[1]])
    if (nb_size == 1) {
        if (strtoi(nb[[1]], base = 10) <= 40) {
            return(paste("<", nb[[1]], "yr", sep = ""))
        } else {
            return(paste(nb[[1]], "+yr", sep = ""))
        }
    } else if (nb_size == 2) {
        return(paste(nb[[1]][1], "-", nb[[1]][2], "yr", sep = ""))
    } else {
        return(NA)
    }
}

#' Keeps only useful columns for UCL-algorithm and eliminates rows
#' that are not in the given interval
format_dataframe <- function(df, start_date = "", end_date = "") {
    keeps <- c("country_code", "year_week", "time", "new_cases")
    if ("variant" %in% colnames(df)) {
        keeps <- append(keeps, "variant")
    } else {
        keeps <- append(keeps, "age_group")
    }
    df <- df[keeps]
    if (start_date != "" & end_date != "") {
        df <- df[is_in_date_range(df$time, start_date, end_date), ]
    }
    return(df)
}

is_in_date_range <- function(date2check_str, start_date_str, end_date_str) {
    date2check <- as.Date(date2check_str, "%Y-%m-%d")
    start <- as.Date(start_date_str, "%Y-%m-%d")
    end <- as.Date(end_date_str, "%Y-%m-%d")
    return(start <= date2check & date2check <= end)
}

remove_exclusive_dates <- function(df1, df2) {
    # Mark as YES if couples date/country aren't in both dataframes else NO
    df1$check <- ifelse(is.na(match(
        paste0(df1$time, df1$country_code),
        paste0(df2$time, df2$country_code)
        )), "NO", "YES")
    df2$check <- ifelse(is.na(match(
        paste0(df2$time, df2$country_code),
        paste0(df1$time, df1$country_code)
        )), "NO", "YES")

    # Only keep row where check equals YES
    df1_without_exclusive <- df1[(df1$check == "YES"), ]
    df2_without_exclusive <- df2[(df2$check == "YES"), ]
    return(list(df1_without_exclusive, df2_without_exclusive))
}

write_country_csv <- function(df) {
    countries <- unique(df$country_code)
    for (country in countries) {
        df2write <- subset(
            df, df$country_code == country, c(
                "country_code", "year_week", "time", "age_group", "variant", "new_cases"))
        write.csv(df2write,
            file = paste(country, "_case_variants.csv", sep = "")
        )
    }
}

message("Getting age_group dataframe... (1/8)")
age_group_df <- get_df_age_group()
message("Getting variants dataframe... (2/8)")
variants_df <- get_df_variants()

message("Normalizing dataframes... (3/8)")
age_group_df <- normalize_dataframe(age_group_df)
variants_df <- normalize_dataframe(variants_df)

message("Formatting dataframes... (4/8)")
filter_start_date <- min(variants_df$time, na.rm = TRUE)
filter_end_date <- max(variants_df$time, na.rm = TRUE)

variants_df_formatted <- format_dataframe(
    variants_df,
    start_date = filter_start_date, end_date = filter_end_date
)
age_group_df_formatted <- format_dataframe(
    age_group_df,
    start_date = filter_start_date, end_date = filter_end_date
)

message("Filtering countries [skipped]... (5/8)")
#filter_country_code <- "HU"
#variants_df_formatted_country <- variants_df_formatted %>%
#    filter(country_code %in% filter_country_code)
#age_group_df_formatted_country <- age_group_df_formatted %>%
#    filter(country_code %in% filter_country_code)

# If 3 is not necessary (all countries):
age_group_df_formatted_country <- age_group_df
variants_df_formatted_country <- variants_df_formatted

message("Removing exclusive dates in both dataset... (6/8)")
dataframes <- remove_exclusive_dates(
    variants_df_formatted_country, age_group_df_formatted_country)
variants_df_formatted_country <- dataframes[[1]]
age_group_df_formatted_country <- dataframes[[2]]

message("Obtaining simulated case & variants dataframe... (7/8)")
case_variants_aggregated <- simulator(
    trainset = variants_df_formatted_country,
    testset = age_group_df_formatted_country, geolocalisation = "country_code",
    outcome = "variant",
    count = "new_cases",
    time = "time",
    factor = 500
)
str(case_variants_aggregated)

message("Writing resulting datasets... (8/8)")
write_country_csv(case_variants_aggregated)

fillgaps <- function(x) {
  goodIdx <- !is.na(x)
  goodVals <- c(x[goodIdx][1], x[goodIdx])
  fillIdx <- cumsum(goodIdx)+1
  goodVals[fillIdx]
}


hospitalised_infected_patients / fillgaps(number_of_operable_beds)

active_days <- 10
if (length(confirmed_cases) > 0) {
    sapply(seq_len(length(confirmed_cases)), function(i) {
    if (i <= 11) {
      return(0)
    } else {
      return(sum(confirmed_cases[1:(i - active_days)], na.rm = T))
    }
  })
} else {
    confirmed_cases
}

#!/usr/bin/env Rscript
args = commandArgs(trailingOnly=TRUE)


if(!require("shiny")) {
  stop("Shiny package is not availabla and it is needed to run the dashboard")
}

 
ui <- function(source_list, timeseries, logo_path) {
  shiny::navbarPage("PANDEM II: Data Surveillance"
    , shiny::tabPanel("Integration progress", integration_page())
    , shiny::tabPanel("Data sources", data_sources_page(source_list))
    , shiny::tabPanel("Data dictionary", variables_page())
    , shiny::tabPanel("Time series", query_page(timeseries))
    , shiny::tabPanel("About", about_page(logo_path))
  )
}


integration_page <- function() {
  shiny::fluidPage(
    shiny::fluidRow(
      shiny::column(12, 
        shiny::h4("Data Surveillance") 
      )
    ),
    shiny::fluidRow(
      shiny::column(1),
      shiny::column(10, 
        DT::dataTableOutput("sources_df")
      ),
      shiny::column(1)
    ), 
    shiny::fluidRow(
      shiny::column(12, 
        shiny::h4("Jobs") 
      )
    ),
    shiny::fluidRow(
      shiny::column(1),
      shiny::column(10, 
        DT::dataTableOutput("jobs_df")
      ),
      shiny::column(1)
    ), 
    shiny::fluidRow(
      shiny::column(2, 
        shiny::actionButton("job_delete", "Delete selected Job"),
      ),
      shiny::column(10) 
    ),
    shiny::fluidRow(
      shiny::column(12, 
        shiny::h4("Integration Issues") 
      )
    ),
    shiny::fluidRow(
      shiny::column(1),
      shiny::column(10, 
        DT::dataTableOutput("issues_df")
      ),
      shiny::column(1)
    )
  )
}

data_sources_page <- function(sources) {
  shiny::fluidPage(
    shiny::fluidRow(
      shiny::column(12, 
        shiny::h4("Data Sources") 
      )
    ),
    shiny::fluidRow(
      shiny::column(1),
      shiny::column(10, 
        shiny::selectInput("source_detail", label = "Source", multiple = FALSE, choices = sources, selected = sources[[1]])
      ),
      shiny::column(1, 
      ),
    ), 
    shiny::fluidRow(shiny::column(12, shiny::h3("Source definition"))),
    shiny::fluidRow(shiny::column(3, shiny::h5("Source")), shiny::column(9,shiny::htmlOutput("source_name"))) ,
    shiny::fluidRow(shiny::column(3, shiny::h5("Description")), shiny::column(9,shiny::htmlOutput("source_description"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Tags")), shiny::column(9,shiny::htmlOutput("source_tags"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Reference User")), shiny::column(9,shiny::htmlOutput("source_user"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Reference Email")), shiny::column(9,shiny::htmlOutput("source_email"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Data Quality")), shiny::column(9,shiny::htmlOutput("source_quality"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Frequency")), shiny::column(9,shiny::htmlOutput("source_frequency"))), 

    shiny::fluidRow(shiny::column(12, shiny::h3("Acquisition"))),
    shiny::fluidRow(shiny::column(3, shiny::h5("Channel")), shiny::column(9,shiny::htmlOutput("source_channel"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Channel info")), shiny::column(9,shiny::htmlOutput("source_channel_info"))), 
   
    shiny::fluidRow(shiny::column(3, shiny::h5("Format")), shiny::column(9,shiny::htmlOutput("source_format"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Format info")), shiny::column(9,shiny::htmlOutput("source_format_info"))), 

    shiny::fluidRow(shiny::column(12, shiny::h5("Data Scope"))),
    shiny::fluidRow(shiny::column(3, shiny::h5("Globals")), shiny::column(9,shiny::htmlOutput("source_globals"))), 
    shiny::fluidRow(shiny::column(3, shiny::h5("Replace data in")), shiny::column(9,shiny::htmlOutput("source_replace"))), 
    
    shiny::fluidRow(shiny::column(12, shiny::h5("Mapping"))),
    shiny::fluidRow(shiny::column(12,
        DT::dataTableOutput("columns_df")
    ))
  )
}

variables_page <- function() {
  shiny::fluidPage(
    shiny::fluidRow(
      shiny::column(12, 
        shiny::h4("Variables") 
      )
    ),
    shiny::fluidRow(
      shiny::column(1),
      shiny::column(10, 
        DT::dataTableOutput("variables_df")
      ),
      shiny::column(1)
    ) 
  )
}


query_page <- function(timeseries) {
  cols = colnames(timeseries)
  if(length(cols) > 0) {
    namedorder = setNames(cols, sapply(1:length(cols), function(i) {
      if(cols[[i]] == "source__source_name") -8 
      else if(cols[[i]] == "indicator__family") -10 
      else if(cols[[i]] == "indicator") -7 
      else if(cols[[i]] == "geo_code") -4
      else if(cols[[i]] == "ref__geo_parent") -5 
      else if(cols[[i]] == "ref__geo_level") -6 
      else if(cols[[i]] == "source__reference_user") -2 
      else if(cols[[i]] == "pathogen_code") -1
      else i
    }))
    cols <- unname(namedorder[as.character(sort(as.integer(names(namedorder))))])
  }
  code_cols = cols[!grepl(".*_label$", cols) & !(cols %in% c("source", "source__table", "source__source_description", "indicator__description", "indicator__unit"))] 
  
  filters <- lapply(code_cols, function(col) {
      label <- sapply(strsplit(col, "__"), function(t) tail(t, 1))[[1]]
      label <- sapply(strsplit(label, "_"), function(t) paste(sapply(t, function(w) paste(toupper(substr(w, 1, 1)), substr(w, 2, nchar(w)), sep = "")), collapse = " "))[[1]]
      if(grepl('.* Code$', label))
        label = substr(label, 1, nchar(label)-5)
      control_id <- paste("ts_filter",col, sep = "_")
      #ok_id <- paste("ts_filter_ok",col, sep = "_")
      #state_id <- paste("ts_filter_state",col, sep = "_")
      shiny::conditionalPanel(
        condition=paste("Object.keys(document.getElementById('",control_id,"').selectize.options).length > 1 || Object.keys(document.getElementById('",control_id,"').selectize.options)[0] != 'NA' ", sep = ""),
        shiny::selectizeInput(control_id, label = label, multiple = TRUE, choices = unique(timeseries[col]), selected = NULL)
      )
      #shiny::conditionalPanel(
      #  condition="false",
      #  shiny::input(state_id, label = "hide")
      #)
      #shiny::conditionalPanel(
      #  condition=paste0("input.",state_id,"== 'hide'"),
      #  shiny::actionButton(ok_id, label = "ok")
      #)
    })

  shiny::fluidPage(
    shiny::fluidRow(
      shiny::column(2, 
        c(
          list(shiny::h4("Filters"))
          ,filters
        )
      ),
      shiny::column(6, 
        shiny::fluidRow(shiny::column(12, shiny::h4("Time Series"))),
        shiny::fluidRow(shiny::column(12, shiny::h5(shiny::htmlOutput("timeseries_count")))),
        shiny::fluidRow(
          shiny::column(6,shiny::radioButtons("timeseries_scale",label="Y-scale", choices = list(`Standard`="std", `Normalized`="normalized", `Log`="log"), selected = "std", inline = TRUE)),
          shiny::column(6,shiny::radioButtons("timeseries_period",label="Time", choices = list(`1 Year`="12", `6 months`="6", `3 months`="3", `1 month`="1", `All`="all"), selected = "12", inline = TRUE))
        ),
        shiny::fluidRow(
          shiny::column(2,shiny::actionButton("filter_filters", "Apply filters")),
          shiny::column(2,shiny::actionButton("plot_series", "Visualize")),
          shiny::column(2,shiny::actionButton("load_series", "Synchronize")),
          shiny::column(2,shiny::actionButton("clear_filters", "Clear")),
          shiny::column(2,shiny::downloadButton("download_data", "Download")),
          shiny::column(6)
        ),
        shiny::fluidRow(
          shiny::column(12,
            shiny::fluidRow(shiny::column(12, plotly::plotlyOutput("timeseries_chart")))
          )
        )
      ),
      shiny::column(4, 
        shiny::h5(shiny::htmlOutput("timeseries_title"))
      )
    )
  )
}



about_page <- function(logo_path) {
  b64 <- base64enc::dataURI(file=logo_path, mime="image/jpeg")
  fluidPage(
    shiny::fluidRow(
      shiny::column(12, 
        shiny::h4("by the pandem consortium") 
      )
    ),
    shiny::fluidRow(
      shiny::column(12, 
        shiny::img(src=b64, height="80%", width="80%", align="center")
      )
    ) 
  )
}


server <- function(input, output, session, ...) {
    `%>%` <- magrittr::`%>%`
    
    rv_reload_sources <- shiny::reactiveVal(0)
    rv_sources <- shiny::reactive({
      shiny::invalidateLater(10000)
      jsonlite::fromJSON("http://localhost:8000/sources")
    })
  
    rv_source_details <- shiny::reactive({
      jsonlite::fromJSON(paste("http://localhost:8000/source_details?source=", 
        URLencode(
          input$source_detail,
          reserved=TRUE
        ), sep = ""
      ))
    })
  
    
    rv_issues <- shiny::reactive({
      job_row <- input$jobs_df_rows_selected
      shiny::validate(
        shiny::need(length(job_row) > 0, 'Please select a job to see its issues')
      )
      job_id = rv_jobs()$jobs$id[[job_row]]
      jsonlite::fromJSON(paste("http://localhost:8000/issues?job_id=", job_id ,sep = ""))
    })
  
    rv_variable_list <- shiny::reactive({
      jsonlite::fromJSON("http://localhost:8000/variable_list")
    })
  
    rv_jobs <- shiny::reactive({
      source_row <- input$sources_df_rows_selected
      shiny::validate(
        shiny::need(length(source_row) > 0, 'Please select a source to see its jobs')
      )
      source_name = rv_sources()$sources$name[[source_row]]
      jsonlite::fromJSON(paste("http://localhost:8000/jobs?source=",URLencode(source_name, reserved=TRUE), sep = ""))
    })
    
    rv_timeseries <- shiny::reactive({
      # Adding a dependency to the reload series button
      x = input$load_series
      #getting the data
      ts <- jsonlite::fromJSON(url("http://localhost:8000/timeseries"))
      df <- tibble::as_tibble(data.frame(ts$timeseries))
      df
    })
    
    # filters reactivity
    x <-shiny::observeEvent(input$filter_filters, {
      df <- rv_timeseries()
      cols = colnames(ts_df)
      cols = cols[!grepl(".*_label$", cols) & !(cols %in% c("source", "source__table", "source__source_description", "indicator__description", "indicator__unit"))] 
      colvals = list() 
      for(ocol in cols) {
        s <- paste("ts_filter",ocol, sep = "_") 
        colvals[[ocol]] = input[[s]]
      }
      for(col in cols) {
        #updating filters
        dff <- rv_timeseries()
        this_select <- paste("ts_filter",col, sep = "_") 
        this_selection <- colvals[col]
        this_selection <- ifelse(this_selection == "NA", NA, this_selection)
        for(ocol in cols) {
          if(ocol != col) { 
            other_select = paste("ts_filter",ocol, sep = "_") 
            oselection = colvals[[ocol]]
            if(!is.null(oselection)) {
              oselection <- ifelse(oselection == "NA", NA, oselection)
              if(is.null(this_selection))
                dff <- dff[dff[[ocol]] %in% oselection,]
              else
                dff <- dff[dff[[ocol]] %in% oselection | dff[[col]] %in% this_selection,]
            }
          }
        }
        label_col <- paste(col, "label", sep = "_")
        values <- dff[[col]]
        if(label_col %in% colnames(dff)) {
          labels <- dff[[label_col]]
        }
        else
          labels <- values
        values <- setNames(values, labels)
        values <- values[sort(unique(names(values)), na.last = TRUE)]
        no_navalues <- values[!is.na(values)]
        no_navalues <- setNames(
          no_navalues,
          sapply(strsplit(names(no_navalues), "_|-| "), function(t) paste(sapply(t, function(w) paste(toupper(substr(w, 1, 1)), tolower(substr(w, 2, nchar(w))), sep = "")), collapse = " "))
        )
        if(NA %in% values) {
          # Setting NA as not available and put it at the end 
          values <- setNames(c(no_navalues, NA), c(names(no_navalues), "Not Available"))
        } else {
          values <- no_navalues 
        }
        selected = colvals[[col]]
        # Updating the select with the respective values
        shiny::updateSelectizeInput(session, this_select,
          choices = values,
          selected = selected,
          server = T
        )
      }
    }, ignoreNULL = F)
    # Count of filtered series 
    output$timeseries_count <- shiny::renderText({
      df <- rv_timeseries()
      cols = colnames(df)
      filters = cols[!grepl(".*_label$", cols) & !(cols %in% c("source", "source_description", "description", "unit"))]
      #updating series count
      for(col in filters) {
          select = paste("ts_filter",col, sep = "_") 
          selection = input[[select]]
          if(!is.null(selection)) {
            selection <- ifelse(selection == "NA", NA, selection)
            df <- df[df[[col]] %in% selection,]
          }
      }
      paste(nrow(df), "time series found")
    })
    
    shiny::observeEvent(input$clear_filters, {
      df <- shiny::isolate(rv_timeseries())
      cols = colnames(df)
      filters = cols[!grepl(".*_label$", cols) & !(cols %in% c("source", "source_description", "description", "unit"))]
      for(col in filters) { 
        select = paste("ts_filter",col, sep = "_")
        selection = shiny::isolate(input[[select]])
        if(!is.null(selection)) {
          shiny::updateSelectizeInput(session, select, choices = NULL, selected = list(), server = T)
        }
      }
    })
  
    # Plot action
    shiny::observeEvent(input$plot_series, {
      df <- rv_timeseries()
      cols = colnames(df)
      filters = cols[!grepl(".*_label$", cols) & !(cols %in% c("source", "source_description", "description", "unit"))]
      # filtering series
      for(col in filters) {
          select = paste("ts_filter",col, sep = "_") 
          selection = input[[select]]
          if(!is.null(selection)) {
            selection <- ifelse(selection == "NA", NA, selection)
            df <- df[df[[col]] %in% selection,]
          }
      }
      # we have a dataframe with the sources to get
      # getting the series combination
      keys = cols[(!grepl(".*_label$", cols) & !grepl("^source__.*", cols) & !grepl("^indicator__.*", cols) & !grepl("^ref__.*", cols))]
      if(nrow(df) > 0) {
        rep = new.env()
        progress_start("Obtaining time series data", rep) 
        series_data = list()
        results <- lapply(1:nrow(df), function(i) {
           progress_set(value = 0.8*i/nrow(df), message = "Getting time series data", rep)
           post_data <- jsonlite::toJSON(as.list(sapply(keys, function(f) df[[f]][[i]])), auto_unbox = TRUE)
           resp <- httr::POST('http://localhost:8000/timeserie', body = post_data, encode="json")
           if(resp$status_code == 200) {
              data <- httr::content(resp)$timeserie
              json <- jsonlite::toJSON(data, auto_unbox=T, null = "null")
              res_df <- as.data.frame(jsonlite::fromJSON(json, simplifyDataFrame=T))
              if (nrow(res_df) > 0) {
                res_df$source <- df[["source__source_name"]][[i]]
              }
              res_df
           } else {
             stop("Error while obatining data series")
           }
        })
        progress_set(value = 0.9, message = "Joining results", rep)
        ts_df <- jsonlite::rbind_pages(results)
        progress_set(value = 0.9, message = "Plotting time series", rep)
        title <- ""#paste(sapply(strsplit(unique(ts_df$indicator), "_|-| "), function(t) paste(sapply(t, function(w) paste(toupper(substr(w, 1, 1)), tolower(substr(w, 2, nchar(w))), sep = "")), collapse = " ")), collase = ", ")
        singles = list()
        details = list()
        if(nrow(ts_df)>0) {
          ts_df$legend <- sapply(ts_df$key, function(v) "")
          # creating labels and title
          for(col in c(keys)) {
            label_col <- paste(col, "label", sep = "_")
            values <- df[[col]]
            if(label_col %in% colnames(df)) {
              labels <- df[[label_col]]
            }
            else
              labels <- values
            values <- setNames(values, labels)
            values <- values[sort(unique(names(values)), na.last = TRUE)]
            labels <- setNames(
              sapply(strsplit(names(values), "_|-| "), function(t) paste(sapply(t, function(w) paste(toupper(substr(w, 1, 1)), tolower(substr(w, 2, nchar(w))), sep = "")), collapse = " ")),
              values
            )
            df_labels <- sapply(1:nrow(ts_df), function(i) {
              json <- ts_df$key[[i]]
              if (length(json) != 0) {
                keys <-  jsonlite::fromJSON(json)
                if(col == "indicator")
                  label = ts_df$indicator[[i]]
                else if(col %in% names(keys)) {
                  label = labels[[as.character(keys[[col]])]]
                }
                else 
                  label = NA
                label
              }
            })
            if(col == "indicator")
              title <- paste(unique(labels), collapse = ", ")
            if(length(values)>0 && !all(is.na(values)))
              details[[col]] = sort(unique(labels))
            if(length(unique(labels))==1 && !is.na(values)) {
              #if(unique(labels) != "All" && col != "period_type")
              #  title = paste(title, ", ", unique(labels), sep = "") 
              singles[[col]] = unique(labels) 
            } else if(length(unique(labels))>1) {
              ts_df$legend = sapply(1:nrow(ts_df), function(i) {
                leg = ts_df[["legend"]][[i]]
                if(nchar(leg)>0)
                  leg = paste(leg, ", ")
                leg = paste(leg, df_labels[[i]])
                leg
              })
            }
          }
        }
        output$timeseries_title <- shiny::renderText({
          elements = c(
            list(
              Sources = unique(df[["source__source_name"]]),
              `Data Quality` = unique(df[["source__data_quality"]]),
              `Sources Description` = unique(df[["source__source_description"]]),
              `Reported By` = unique(df[["source__reference_user"]]),
              `Indicator` = unique(df[["indicator"]]),
              `Indicator Family` = unique(df[["indicator__family"]]),
              `Indicator Description` = unique(df[["indicator__description"]]),
              `Indicator Unit` = unique(df[["indicator__unit"]])
            ),
            details
          )
          paste(
            "<UL>",
            paste(
              "<LI><B>",
              names(elements),
              "</B>:",
              "<UL>",
              sapply(elements, function(e){
                 paste("<LI>",e,"</LI>", collapse = "")
              }),
              "</UL></LI>",
              sep ="", 
              collapse = ""
            ),
            "</UL>",
            sep = ""
          )
        })
        
        output$timeseries_chart <- plotly::renderPlotly({
           # Validate if minimal requirements for rendering are met 
           progress_set(value = 0.15, message = "Generating line chart", rep)
           ts_df$date <- as.Date(ts_df$date)
           if (nrow(ts_df) > 0) {
            chart <- plot_timeseries(ts_df, title = title, scale = input$timeseries_scale, period = input$timeseries_period)
           
            # Setting size based on container size
            height <- session$clientData$output_line_chart_height
            width <- session$clientData$output_line_chart_width
            
            # returning empty chart if no data is found on chart
            chart_not_empty(chart)
            
  
            # transforming chart on plotly
            gg <- plotly::ggplotly(chart, height = height, width = width, tooltip = c("label")) %>% plotly::config(displayModeBar = FALSE) 
           }
        }) 
        progress_close(env = rep)
      }
    })
    
    # Download data 
    output$download_data <- shiny::downloadHandler(
      filename = function() { paste("timeserie-", strftime(Sys.time(), "%Y-%m-%d_%H-%M-%S"), ".csv", sep="")}, 
      content = function(file) {
        df <- rv_timeseries()
        cols = colnames(df)
        filters = cols[!grepl(".*_label$", cols) & !(cols %in% c("source", "source_description", "description", "unit"))]
        # filtering series
        for(col in filters) {
            select = paste("ts_filter",col, sep = "_") 
            selection = input[[select]]
            if(!is.null(selection)) {
              selection <- ifelse(selection == "NA", NA, selection)
              df <- df[df[[col]] %in% selection,]
            }
        }
        # we have a dataframe with the sources to get
        # getting the series combination
        keys = cols[(!grepl(".*_label$", cols) & !grepl("^source__.*", cols) & !grepl("^indicator__.*", cols) & !grepl("^ref__.*", cols))]
        if(nrow(df) > 0) {
          rep = new.env()
          progress_start("Obtaining time series data", rep) 
          series_data = list()
          results <- lapply(1:nrow(df), function(i) {
             progress_set(value = 0.8*i/nrow(df), message = "Getting time series data", rep)
             post_data <- jsonlite::toJSON(as.list(sapply(keys, function(f) df[[f]][[i]])), auto_unbox = TRUE)
             resp <- httr::POST('http://localhost:8000/timeserie', body = post_data, encode="json")
             if(resp$status_code == 200) {
                data <- httr::content(resp)$timeserie
                json <- jsonlite::toJSON(data, auto_unbox=T, null = "null")
                res_df <- as.data.frame(jsonlite::fromJSON(json, simplifyDataFrame=T))
                if (nrow(res_df) > 0) {
                  res_df$source <- df[["source__source_name"]][[i]]
                  res_df$ts_id <- i
                  keys = res_df$key
                  res_df$date_var <- NULL
                  res_df$key <- NULL
                  #Adding columns by keys
                  keys_df <- jsonlite::fromJSON(paste("[", paste(keys, collapse = ","), "]"))
                  for(c in colnames(keys_df)) {
                    res_df[c] = keys_df[c]
                  }
                }
                res_df
             } else {
               stop("Error while obatining data series")
             }
          })
          progress_set(value = 0.9, message = "Joining results", rep)
          ts_df <- jsonlite::rbind_pages(results)
          progress_set(value = 0.9, message = "Dowloading time series", rep)
          singles = list()
          details = list()
          progress_close(env = rep)
          
          write.csv(ts_df, file) 
        }
    })  
  
    # Listing source progress
    output$sources_df <- DT::renderDataTable({
        observed <- rv_reload_sources()
        sources = shiny::isolate(rv_sources())
        data <- tibble::as_tibble(data.frame(
          Name = sources$sources$name, 
          Progress = sources$sources$progress,
          Step = sources$sources$`step`, 
          Status=sources$sources$`status`,
          `Last Import Started` = substr(sources$sources$`last_import_start`, 1, 19), 
          `Last Import Ended` = substr(sources$sources$`last_import_end`, 1, 19), 
          `Next Check` = substr(sources$sources$`next_check`, 1, 19), 
          `Files` = sources$sources$`files`,  
          `Mb` = round(sources$sources$`size`/1024, 1),  
          `Issues` = sources$sources$`issues`,  
           check.names = FALSE
        )) %>% dplyr::filter(!is.na(.data$Step)) 
  
        DT::datatable(
          data, 
          escape = FALSE,
          options = list(
            searching = FALSE,
            pageLength = 50 
            #dom = 't'
          ),
          rownames = TRUE,
          selection = 'single'
       ) %>%
        DT::formatStyle('Progress',
          background = DT::styleColorBar(c(0,1), 'lightblue'),
          backgroundSize = '98% 88%',
          backgroundRepeat = 'no-repeat',
          backgroundPosition = 'left') %>%
        DT::formatPercentage(c("Progress"), 2)
      })
  
    shiny::observe({
        sources = rv_sources()
        data <- tibble::as_tibble(data.frame(
          Name = sources$sources$name, 
          Progress = sources$sources$progress,
          Step = sources$sources$`step`, 
          Status=sources$sources$`status`,
          `Last Import Started` = substr(sources$sources$`last_import_start`, 1, 19), 
          `Last Import Ended` = substr(sources$sources$`last_import_end`, 1, 19), 
          `Next Check` = substr(sources$sources$`next_check`, 1, 19), 
          `Files` = sources$sources$`files`,  
          `Mb` = round(sources$sources$`size`/1024, 1),  
          `Issues` = sources$sources$`issues`,  
           check.names = FALSE
        )) %>% dplyr::filter(!is.na(.data$Step)) 
        
        proxy <- DT::dataTableProxy('sources_df')
        DT::replaceData(proxy, data, clearSelection = "none")
    }) 
      
    output$source_name <- shiny::renderText({
        names(rv_source_details()$definitions)[[1]]
    })
  
    output$source_description <- shiny::renderText({
        details <- rv_source_details()$definitions[[1]]
        details$scope$source_description
    })
  
    output$source_frequency <- shiny::renderText({
        details <- rv_source_details()$definitions[[1]]
        details$scope$frequency
    })
    output$source_quality <- shiny::renderText({
        details <- rv_source_details()$definitions[[1]]
        details$scope$data_quality
    })
  
    output$source_tags <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      paste(details$scope$tags, collapse = ", ")
    })
  
    output$source_user  <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      details$scope$reference_user
    })
  
    output$source_email  <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      details$scope$reporting_email
    })
  
    output$source_channel <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      details$acquisition$channel$name
    })
  
    output$source_channel_info <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      items <- names(details$acquisition$channel)
      items <- items[items != "name"]
      values <- details$acquisition$channel[items]
      paste("<UL><LI>", paste(items, values, collapse = "</LI><LI>", sep = ": "), "</LI></UL>", sep = "")
    })
   
    output$source_format <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      details$acquisition$format$name
    })
  
    output$source_format_info <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      items <- names(details$acquisition$format)
      items <- items[items != "name"]
      values <- details$acquisition$format[items]
      paste("<UL><LI>", paste(items, values, collapse = "</LI><LI>", sep = ": "), "</LI></UL>", sep = "")
    })
  
    output$source_globals <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      items <- details$scope$globals$variable
      values <- details$scope$globals$value
      paste("<UL><LI>", paste(items, values, collapse = "</LI><LI>", sep = ": "), "</LI></UL>", sep = "")
    })
  
    output$source_replace <- shiny::renderText({
      details <- rv_source_details()$definitions[[1]]
      items <- details$scope$update_scope$variable
      values <- details$scope$upsate_scope$value
      paste("<UL><LI>", paste(items, values, collapse = "</LI><LI>", sep = ": "), "</LI></UL>", sep = "")
    })
    
    output$columns_df <- DT::renderDataTable({
      details <- rv_source_details()$definitions[[1]]
      items <- details$scope$update_scope$variable
      data <- tibble::as_tibble(data.frame(
        Column = details$columns$name, 
        Variable = details$columns$variable,
        check.names = FALSE
      ))  
  
      DT::datatable(
        data, 
        escape = FALSE,
        options = list(
          searching = FALSE,
          pageLength = 200
          #dom = 't'
        ),
        rownames = FALSE,
        selection = 'none'
     ) 
    })
   
    shiny::observe({
      observed <- input$sources_df_rows_selected
      output$jobs_df <- DT::renderDataTable({
        jobs = shiny::isolate(rv_jobs())$jobs
        data <- tibble::as_tibble(data.frame(
          Id = jobs$id, 
          Source = jobs$source, 
          Progress = jobs$progress, 
          Step = jobs$step, 
          Status = jobs$status,
          Started = substr(jobs$start, 1, 19), 
          Ended = substr(jobs$end, 1, 19), 
          Files = jobs$files,  
          Mb = round(jobs$size/1024, 1),  
          Issues = jobs$issues,  
          check.names = FALSE
        )) 
  
        DT::datatable(
          data, 
          escape = FALSE,
          options = list(
            searching = FALSE,
            pageLength = 50 
            #dom = 't'
          ),
          rownames = TRUE,
          selection = 'single'
       ) %>%
        DT::formatStyle('Progress',
          background = DT::styleColorBar(c(0,1), 'lightblue'),
          backgroundSize = '98% 88%',
          backgroundRepeat = 'no-repeat',
          backgroundPosition = 'left') %>%
        DT::formatPercentage(c("Progress"), 2)
      })
    })
  
    shiny::observe({
      observed <- input$jobs_df_rows_selected
      output$issues_df <- DT::renderDataTable({
        issues <- shiny::isolate(rv_issues())$issues
        data <- tibble::as_tibble(data.frame(
             Id = issues$id,
             `Job Id` = issues$job_id,
             Source = issues$tag,
             Table = issues$source,
             `Severity` = issues$issue_severity,
             `Issue Type` = issues$issue_type,
             Step = issues$step,
             `Line Number` = issues$line,
             File = issues$file,
             Message = issues$message,
             `Raised On` = substr(issues$raised_on, 1, 19),
             check.names = FALSE
        ))  
  
        DT::datatable(
          data, 
          escape = FALSE,
          options = list(
            searching = TRUE,
            pageLength = 200
            #dom = 't'
          ),
          rownames = FALSE,
          selection = 'none'
       ) 
      })
    })
  
    output$variables_df <- DT::renderDataTable({
      variables <- rv_variable_list()$variables
      data <- tibble::as_tibble(data.frame(
        `Family` = variables$data_family,
        `Type` = variables$type,
        `Variable` = gsub("_", " ", variables$variable),
        `Base Variable` = gsub("_", " ", variables$base_variable),
        `Definition` = variables$description,
         Unit = variables$unit,
        `Partition` = 
           paste("<UL>", sapply(variables$partition, function(r) paste(sapply(r, function(i) paste("<LI>", i, "</LI>", collapse = "", sep = "")), collapse = "")), "</UL>", sep = ""),
        `Modifiers` = 
           sapply(variables$modifiers, function(df) if(nrow(df) == 0) "" else paste("<UL><LI>", paste(df$variable, ": ", df$value, sep = "", collapse = "</LI><LI>"), sep = "", "</LI></UL>")),
        `Links` = sapply(variables$linked_attributes, function(v) paste(v, collapse = ', ')),
        `Formula` = variables$formula,
        check.names = FALSE
      ))  
  
      DT::datatable(
        data, 
        escape = FALSE,
        options = list(
          searching = TRUE,
          pageLength = 200
          #dom = 't'
        ),
        rownames = FALSE,
        selection = 'none'
     ) 
    })
  
    shiny::observeEvent(input$job_delete, {
      shiny::showModal(shiny::modalDialog(
        title = "Confirm deletion",
        "Are you sure you want to permanently delete the job",
        footer = shiny::tagList(shiny::actionButton("job_do_delete", "Yes"), shiny::modalButton("Cancel"))
      ))
    })
    
    shiny::observeEvent(input$job_do_delete, {
      job_row <- input$jobs_df_rows_selected
      job_id = rv_jobs()$jobs$id[[job_row]]
      httr::DELETE(paste('http://localhost:8000/jobs?job_id=', job_id, sep = ""))
      #rv_reload_sources(shiny::isolate(rv_reload_sources()) + 1)
      source_row <- input$sources_df_rows_selected
      proxy <- DT::dataTableProxy('sources_df')
      DT::selectRows(proxy, NULL)
      DT::selectRows(proxy, source_row)
      shiny::removeModal()
    })
}

# Plot the time series chart for shiny app
plot_timeseries <- function(df, title, scale = "std", period = "12") {
  #Importing pipe operator
  `%>%` <- magrittr::`%>%`
  # getting regions and countries 
  #turning off the scientific pen
  old <- options()
  on.exit(options(old))
  options(scipen=999)

  # deleting old dates depending on period
  if(period != "all") {
    df <- df[as.numeric(difftime(max(df$date), df$date, units = "days")) < as.numeric(period)*30,]
  }
  # adding hover texts
  df$Details <- sapply(1:nrow(df), function(i) {
    paste(
      "",
      df$value[[i]],
      paste("date:",  df$date[[i]]),
      df$source[[i]],
      paste(strsplit(df$legend[[i]], ", ")[[1]], collapse = "\n"),
      sep = "\n"
    )

  })
  df$y <- if(scale == "std") {
    df$value
  } else if(scale == "log") {
    log(df$value)
  } else if(nrow(df)>0) {
    maxs = list()
    for(i in 1:nrow(df)) {
      key = paste(df$indicator[[i]], df$source[[i]], df$key[[i]])
      if(!exists(key, where = maxs))
        maxs[[key]] = max(0, df$value[[i]], na.rm = TRUE)
      else
        maxs[[key]] = max(maxs[[key]], df$value[[i]], na.rm = TRUE)
    }
    sapply(1:nrow(df), function(i) {
      key = paste(df$indicator[[i]], df$source[[i]], df$key[[i]])
      if(!is.na(maxs[[key]]) && maxs[[key]] != 0) 
        df$value[[i]]/maxs[[key]] 
      else 0
    })
  } else 
    numeric(0)
  # Calculating breaks of y axis
  #y_breaks <- unique(floor(pretty(seq(0, (max(df$value, na.rm=T) + 1) * 1.1))))
  # plotting
  labels <- unique(df$legend)
  fig_line <- ggplot2::ggplot(df, ggplot2::aes(x = .data$date, y = .data$y, color = .data$legend, label = .data$Details)) +
    ggplot2::geom_line() + #ggplot2::aes(colour=.data$key)) +
    ggplot2::geom_point(size = 0.5) +
    # Title
    ggplot2::labs(
     title= title,
     color="Legend"
    ) +
    ggplot2::xlab("Date") + 
    ggplot2::ylab(if(scale == "std") "Indicator" else if(scale == "log") "Log" else "[0-1] Max Normalized") +
    #ggplot2::scale_y_continuous(breaks = y_breaks, limits = c(0, max(y_breaks)), expand=c(0 ,0))+
    ggplot2::theme_classic(base_family = get_font_family()) +
    ggplot2::theme(plot.title = ggplot2::element_text(hjust = 0.5, size = 12, face = "bold",lineheight = 0.9),
      axis.text = ggplot2::element_text(colour = "black", size = 8),
      axis.text.x = ggplot2::element_text(angle = 45, hjust = 1, vjust = 0.5, 
                                          margin = ggplot2::margin(-15, 0, 0, 0)),
      axis.title.x = ggplot2::element_text(margin = ggplot2::margin(30, 0, 0, 0), size = 10),
      axis.title.y = ggplot2::element_text(margin = ggplot2::margin(-25, 0, 0, 0), size = 10),
      legend.position= if(length(unique(df$legend)) < 50 && max(nchar(df$legend))< 20) "bottom" else "none"
    )
  fig_line

}

# Helper function to get the font family
get_font_family <- function(){
  if(.Platform$OS.type == "windows" && is.null(grDevices::windowsFonts("Helvetica")[[1]]))
    grDevices::windowsFonts(Helvetica = grDevices::windowsFont("Helvetica"))
  "Helvetica"
}


# Functions for managing calculation progress
progress_start <- function(start_message = "processing", env = cd) {
  progress_close(env = env)
  env$progress <- shiny::Progress$new()
  env$progress$set(message = start_message, value = 0)
}
progress_close <- function(env = cd) {
  if(exists("progress", where = env)) {
    env$progress$close()
    rm("progress", envir = env)
  }
}

progress_set <- function(value, message  = "processing", env = cd) {
  if(!is.null(env$progress$set))
    env$progress$set(value = value, detail = message)
}
  
# validate that chart is not empty
chart_not_empty <- function(chart) {
  shiny::validate(
     shiny::need(!("waiver" %in% class(chart$data)), chart$labels$title)
  )
} 

# Shiny app initialization
source_list <- NULL
while(is.null(source_list)) {
  source_list = tryCatch(jsonlite::fromJSON("http://localhost:8000/source_details"), error = function(e) NULL)
  if(is.null(source_list)) {
    message("going to sleep for 2 seconds until pandem2source API is up")
    Sys.sleep(2)
  }
}

ts <- jsonlite::fromJSON(url("http://localhost:8000/timeseries"))
ts_df <- tibble::as_tibble(data.frame(ts$timeseries))

# test if there is at least one argument: if not, return an error
if (length(args)==0) {
  options = options(shiny.fullstacktrace = TRUE)
}
if (length(args)>0) {
  options = options(shiny.fullstacktrace = TRUE, shiny.port = as.integer(args[1]))
}
if (length(args)>1) {
  logo_path = args[2]
} else {
  logo_path = ""
}
shiny::shinyApp(ui = ui(source_list = source_list, timeseries = ts_df, logo_path = logo_path), server = server, options = options )
